(function(angular, $, _) {
  console.log('v8');

  angular.module('updaterecur').config(function($routeProvider) {
    $routeProvider.when('/inlays/UpdateGiving/:id', {
      controller: 'InlayUpdateGiving',
      controllerAs: '$ctrl',
      templateUrl: '~/updaterecur/InlayUpdateGiving.html',

      // If you need to look up data when opening the page, list it out
      // under "resolve".
      resolve: {
        various: function($route, crmApi4) {
          const params = {
            inlayTypes: ['InlayType', 'get', {}, 'class'],
            messageTpls: ['MessageTemplate', 'get', {
              select: ["id", "msg_title", "msg_subject"],
              where: [
                ["is_active", "=", true],
                ["is_sms", "=", false],
                ["workflow_id", "IS NULL"]
              ],
              orderBy: { msg_title: 'ASC' }
            },
              'id'],
            fromAddresses: ['OptionValue', 'get', {
              select: ["label", "value"],
              where: [["option_group_id:name", "=", "from_email_address"], ["is_active", "=", true]],
              orderBy: { "is_default": "DESC" },
            }],
            financialTypes: ['FinancialType', 'get', {
              select: ['id', 'name'],
              where: [
                ['is_active', '=', true]
              ]
            }],
            allGroups: ['Group', 'get', {
              select: ["id", "title"],
              where: [["is_hidden", "=", 0], ["is_active", "=", true]],
              orderBy: { "name": "ASC" }
            }],
          };
          if ($route.current.params.id > 0) {
            params.inlay = ['Inlay', 'get', { where: [["id", "=", $route.current.params.id]] }, 0];
          }
          return crmApi4(params);
        }
      }
    });
  }
  );

  // The controller uses *injection*. This default injects a few things:
  //   $scope -- This is the set of variables shared between JS and HTML.
  //   crmApi4, crmStatus, crmUiHelp -- These are services provided by civicrm-core.
  angular.module('updaterecur').controller('InlayUpdateGiving', function($scope, crmApi4, crmStatus, crmUiHelp, various) {
    // The ts() and hs() functions help load strings for this module.
    var ts = $scope.ts = CRM.ts('updaterecur');
    // var hs = $scope.hs = crmUiHelp({file: 'CRM/updaterecur/InlayUpdateGiving'}); // See: templates/CRM/updaterecur/InlayUpdateGiving.hlp
    // Local variable for this controller (needed when inside a callback fn where `this` is not available).
    var ctrl = this;

    $scope.inlayType = various.inlayTypes['Civi\\Inlay\\UpdateGiving'];
    console.log({ various }, $scope.inlayType);
    $scope.allGroups = various.allGroups;
    $scope.messageTpls = various.messageTpls;
    $scope.financialTypes = various.financialTypes;
    $scope.mailingGroups = various.mailingGroups;
    $scope.fromAddresses = various.fromAddresses;

    if (various.inlay) {
      $scope.inlay = various.inlay;
    }
    else {
      $scope.inlay = {
        'class': 'Civi\\Inlay\\UpdateGiving',
        name: 'New ' + $scope.inlayType.name,
        public_id: 'new',
        id: 0,
        config: JSON.parse(JSON.stringify($scope.inlayType.defaultConfig)),
      };
      $scope.inlay.config.priceSetID = 'new';
    }

    $scope.save = function() {
      // Export the selected devices to inlay.config.devices
      // inlay.config.devices = $scope.devices.filter(dev => dev.selected).map(dev => dev.name);


      return crmStatus(
        // Status messages. For defaults, just use "{}"
        { start: ts('Saving...'), success: ts('Saved') },
        crmApi4('Inlay', 'save', { records: [$scope.inlay] })
      ).then(r => {
        console.log("save result", r);
        window.location = CRM.url('civicrm/a?#inlays');
      });
    }; // End of save()

  });

})(angular, CRM.$, CRM._);
