(function(angular, $, _) {
  "use strict";

  angular.module('updaterecur').controller('crmSearchTaskChangeSubscription', function($scope, $http, searchTaskBaseTrait, crmApi4, dialogService) {

    var ts = $scope.ts = CRM.ts('upgraderecur'), // ???
      // Combine this controller with model properties (ids, entity, entityInfo) and searchTaskBaseTrait
      ctrl = angular.extend(this, $scope.model, searchTaskBaseTrait);

    // this.entityTitle = this.getEntityTitle();
    this.newAmount = null;
    this.reason = '';

    this.startQueuing = function() {
      let errs = [];
      if (!this.newAmount || !(parseFloat(this.newAmount) > 0)) {
        errs.push(ts('A valid new amount figure is required. Use . for decimal separator, and no thousands separator.'));
      }
      if (!this.reason) {
        errs.push(ts('A reason is required. e.g. Change amount to ...'));
      }
      if (errs.length > 0) {
        CRM.alert(errs.join(' '), ts('Error'), 'error');
        return;
      }

      ctrl.start({
        newAmount: this.newAmount,
        reason: this.reason
      });
    };

    this.onSuccess = function() {
      CRM.alert(ts('Successfully queued %1 changes. They will be processed in the background.', {1: ctrl.ids.length}), ts('Changes Queued'), 'success');
      this.close();
    };

    this.onError = function() {
      // There does not seem to be a way to get the error.
      CRM.alert(ts('An error occurred while attempting to queue the changes. Some may have worked, some may not.'), ts('Error'), 'error');
      this.run = null;
      // this.cancel();
    };

  });
})(angular, CRM.$, CRM._);

