<?php
use CRM_Updaterecur_ExtensionUtil as E;

/**
 * Job.Performsubscriptionchanges API specification (optional)
 * This is used for documentation and validation.
 *
 * @param array $spec description of fields supported by this API call
 *
 * @see https://docs.civicrm.org/dev/en/latest/framework/api-architecture/
 */
function _civicrm_api3_job_Performsubscriptionchanges_spec(&$spec) {
  $spec['time_limit']['api.required'] = 0;
  // Stop after 10s (this is quite a low limit, you should call from a CLI environment without time limits and consider raising this or setting to 0 to disable limit.)
  $spec['time_limit']['api.default'] = 10;
  $spec['time_limit']['description'] = "Stop after taking this many seconds. Set to 0 for no limit. If running from CLI script (not http cron) advise setting to 300 (5 mins)";
}

/**
 * Job.Performsubscriptionchanges API
 *
 * @param array $params
 *
 * @return array
 *   API result descriptor
 *
 * @see civicrm_api3_create_success
 *
 * @throws API_Exception
 */
function civicrm_api3_job_Performsubscriptionchanges($params) {
  if ($params['time_limit'] == 0) {
    $timeLimit = FALSE;
  }
  else {
    $timeLimit = time() + $params['time_limit'];
  }

  $results = (new Civi\UpdaterecurWorker($timeLimit))->queueRun();
  return civicrm_api3_create_success($results, $params, 'Job', 'Performsubscriptionchanges');
}

