<?php

require_once 'updaterecur.civix.php';
// phpcs:disable
use CRM_Updaterecur_ExtensionUtil as E;
use Civi\Token\TokenRow;
use Civi\Updaterecur\Utils;

// phpcs:enable

/**
 * Implements hook_civicrm_container().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_container/
 */
function updaterecur_civicrm_container($container) {
  // https://docs.civicrm.org/dev/en/latest/hooks/usage/symfony/
  //Civi::dispatcher()
  $d = $container->findDefinition('dispatcher');
  $d->addMethodCall('addListener', ['hook_inlay_registerType', [Civi\Inlay\UpdateGiving::class, 'register']]);
  $d->addMethodCall('addListener', ['civi.token.list', '\\Civi\\Updaterecur\\Utils::registerTokens'])->setPublic(TRUE);
  $d->addMethodCall('addListener', ['civi.token.eval', '\\Civi\\Updaterecur\\Utils::evaluateTokens'])->setPublic(TRUE);
}

/**
 * Implements hook_civicrm_config().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_config/
 */
function updaterecur_civicrm_config(&$config) {
  _updaterecur_civix_civicrm_config($config);
}

/**
 * Implements hook_civicrm_install().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_install
 */
function updaterecur_civicrm_install() {
  _updaterecur_civix_civicrm_install();
}

/**
 * Implements hook_civicrm_enable().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_enable
 */
function updaterecur_civicrm_enable() {
  _updaterecur_civix_civicrm_enable();
}

// --- Functions below this ship commented out. Uncomment as required. ---

/**
 * Implements hook_civicrm_preProcess().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_preProcess
 */
//function updaterecur_civicrm_preProcess($formName, &$form) {
//
//}

/**
 * Implements hook_civicrm_navigationMenu().
 *
 * @link https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_navigationMenu
 */
function updaterecur_civicrm_navigationMenu(&$menu) {
  _updaterecur_civix_insert_navigation_menu($menu, 'Contributions', array(
    'label' => E::ts('Find Recurring Contributions to change'),
    'name' => 'updaterecur_find_form',
    'url' => 'civicrm/change-recurring-contributions',
    'permission' => 'edit contributions',
    'operator' => 'OR',
    'separator' => 0,
  ));
  _updaterecur_civix_navigationMenu($menu);

  _updaterecur_civix_insert_navigation_menu($menu, 'Contributions', array(
    'label' => E::ts('Monitor Recurring Contribution changes'),
    'name' => 'updaterecur_find_form',
    'url' => 'civicrm/recurring-changes',
    'permission' => 'edit contributions',
    'operator' => 'OR',
    'separator' => 0,
  ));
  _updaterecur_civix_navigationMenu($menu);
}

/**
 *
 * Add to the list of tasks available on ContributionRecur records.
 *
 */
function updaterecur_civicrm_searchKitTasks(array &$tasks, bool $checkPermissions, ?int $userId = NULL) {
  // @todo limit by permission
  $tasks['ContributionRecur']['updaterecur_change_subscriptions_task'] = [
    'module' => 'updaterecur',
    'title' => ts('Change Recurring Contribution subscriptions'),
    // ? 'class' => single quick form or array of them? 'CRM_Contribute_Form_Task_Delete',
    // 'result' => bool ???
    //
    'icon' => 'fa-gear',
    'uiDialog' => ['templateUrl' => '~/updaterecur/crmSearchTaskChangeSubscription.html'],
    // We MUST make the user choose which records to act on.
    'number' => '> 0',

    // 'crmPopup' => [
    //   'path' => "''",
    //   'query' => "{id: ids.join(',')}",
    // ],

  ];
}
